\ ----------------------------------------------------------------------
\ LANGUAGE    : AVR ByteForth vsn 2.00
\ PROJECT     : Ushi de belofte
\ DESCRIPTION : Ushi volgt een zwarte lijn
\ CATEGORY    : Applicatie, afmeting: 1094 bytes.
\ AUTHOR      : Willem Ouwerkerk, May 05, 2002
\ LAST CHANGE : Willem Ouwerkerk, August 15, 2003
\ ----------------------------------------------------------------------

90S2313                                 \ Selecteer target
NEEDS TARGET.FRT                        \ Laad cpu specifiek deel

INCLUDE USHIO-1.FRT

\ 2 = vloer-links  4 = vloer-rechts.
\ Toon data op de dichtsbijzijnde leds.
MACRO: STREEP       ( -- lijn-data )
    FROM VLOER-LINKS  TO LINKS-VOOR
    FROM VLOER-RECHTS TO RECHTS-VOOR
    FROM VLOER-ACHTER TO ACHTER
    TAFELRAND 6 AND
    ;

: HARDER            ( -- )
    FROM TEMPO 2 +  SNELHEID
    ;

: ZACHTER           ( -- )
    FROM TEMPO 2 -  0 MAX SNELHEID
    ;

FLAG GEKOZEN?                           \ Bevat draairichting, true is rechts
FLAG ONTHOUD?                           \ True als keuze gemaakt is

\ Dobbel om bij een splitsing een keus te kunnen maken.
: KIES              ( -- )
    ONTHOUD? 0= IF
        2 CHOOSE TO GEKOZEN?
        SET ONTHOUD?
    THEN
    GEKOZEN? IF RECHTS ELSE LINKS THEN  250 MS
    ;

\ Houdt Ushi op een zwarte lijn, dobbel bij een splitsing.
: VOLG              ( -- )
    CASE  STREEP
        0 OF  VOORUIT CLEAR ONTHOUD?  ENDOF
        2 OF  LINKS                   ENDOF
        4 OF  RECHTS                  ENDOF
        6 OF  KIES                    ENDOF
    ENDCASE
    1 MS
    ;

: DOOL              ( -- )
    BEGIN  VOLG  RCKEY? UNTIL
    ;

\ Een RC-toetscode tegelijkertijd
: SKIP-RCKEY        ( -- )
    150 MS  RCKEY? IF  RCKEY DROP  THEN
    ;

FLAG STOP?

: START/STOP        ( -- )
    STOP? IF  STOP  ELSE  VOORUIT  THEN  TOGGLE STOP?
    ;

\ Handel RC-commando's af
: AFSTANDBEDIENING  ( -- )
    RCKEY? IF
        CASE  RCKEY  SKIP-RCKEY
            12 OF   DOOL        ENDOF
            13 OF   START/STOP  ENDOF
            16 OF   HARDER      ENDOF
            17 OF   ZACHTER     ENDOF
            32 OF   RECHTSOM    ENDOF
            33 OF   LINKSOM     ENDOF
        ENDCASE
    THEN
    ;

: LEDS-ACTIEF       ( -- )
    1 SETDIR LINKS-VOOR
    1 SETDIR RECHTS-VOOR
    1 SETDIR ACHTER
    ;

\ Volg een lijn tot de batterijen leeg zijn.
:MAIN               ( -- )
    SETUP-USHI  30 SNELHEID  STOP
    LEDS-ACTIEF  SET STOP?
    BEGIN  AFSTANDBEDIENING  AGAIN
    ;

                              ( Einde )
