\ ----------------------------------------------------------------------
\ LANGUAGE    : AVR ByteForth vsn 2.00
\ PROJECT     : Ushi-3 test nummer 3
\ DESCRIPTION : Regel de motoren af.
\ CATEGORY    : Applicatie, afmeting: 812 bytes.
\ AUTHOR      : Willem Ouwerkerk, December 09, 2001
\ LAST CHANGE : Willem Ouwerkerk, Oktober 20, 2002
\ ----------------------------------------------------------------------

90S2313                                 \ Selecteer target
NEEDS TARGET.FRT                        \ Laad cpu specifiek deel
4 SET-CRYSTAL                           \ Gebruik 4 MHz kristal
NEEDS MS.FRT                            \ Laad geschikte MS versie

INCLUDE USHIO-1.FRT                     \ Laad basis Ushi-I/O routines


DOC over het afregelen van de motoren

De servo's zijn aangesloten op connector 10 en 11.
De RC5-ontvanger op connector 3 en 4 en de bumperschakelaar
aan de achterzijde zit op connector 15.

Ushi staat na het opstarten stil, met de bumpersensoren
worden Ushis bewegingen geactiveerd. Staat ushi na het
opstarten niet stil, probeer hem dan met de in de servo's
ingebouwde potmeters stil te krijgen.

Als de motoren niet draaien controleer dan eerst of de 
stekkertjes op de goede manier op de print zijn gestoken.
Zitten ze goed controleer dan of de ombouw correct gedaan is.

Als Ushi met de potmeters in de servo's niet tot stilstand
te krijgen is, pas dan de konstante STILSTAND# aan in de
file USHIO-1.FRT zie ook de file STOP.FRT

De bumper sensoren hebben hier de volgende functies:

Stop Ushi       = Achterbumper ingedrukt
Ushi vooruit    = Bumper linksopzij ingedrukt
Ushi rechts     = Bumper linksvoor ingedrukt
Ushi links      = Bumper rechtsvoor ingedrukt
Ushi achteruit  = Bumper rechtsopzij ingedrukt

ENDDOC


\ Gebruik de bumperschakelaars om de bewegingen van Ushi te testen.
: MOTOR-TEST        ( -- )
    FROM ACHTER 0=       IF  STOP EXIT       THEN
    FROM LINKS-OPZIJ 0=  IF  VOORUIT EXIT    THEN
    FROM LINKS-VOOR 0=   IF  RECHTS EXIT     THEN
    FROM RECHTS-VOOR 0=  IF  LINKS EXIT      THEN
    FROM RECHTS-OPZIJ 0= IF  ACHTERUIT EXIT  THEN
    ;

: SEC  FOR  4 FOR 250 MS NEXT  NEXT ;

:MAIN               ( -- )
    SETUP-USHI  50 SNELHEID  STOP
    BEGIN
        MOTOR-TEST
    AGAIN
    ;

                              ( Einde )
