\ ----------------------------------------------------------------------
\ LANGUAGE    : AVR ByteForth vsn 2.00
\ PROJECT     : Ushi de belofte
\ DESCRIPTION : Ushi test US-afstandmeter
\ CATEGORY    : Applicatie, afmeting: 968 bytes.
\ AUTHOR      : Willem Ouwerkerk, August 18, 2003
\ LAST CHANGE : Willem Ouwerkerk, August 18, 2003
\ ----------------------------------------------------------------------

90S2313                                 \ Selecteer target
NEEDS TARGET.FRT                        \ Laad cpu specifiek deel

INCLUDE USHIO-1.FRT


DOC het testen van de US-afstandmeter

De leds van Ushi-3 zijn aangesloten op poort-B, op 
PD.0 en PD.1 is de GP2D02- of MUS-interface aangesloten.

Ushi toont op zijn leds de door de GP2D02 of MUS gemeten
afstand in binaire vorm, het binaire getal wordt groter
als de afstand toeneemt.

ENDDOC


: HARDER            ( -- )
    FROM TEMPO 2 +  SNELHEID
    ;

: ZACHTER           ( -- )
    FROM TEMPO 2 -  0 MAX SNELHEID
    ;

\ Gebruik de leds om de door GP2D02 of MUS gemeten afstand te tonen
: AFSTANDEN         ( -- )
    AFSTAND  INVERT TO PB
    ;

: MEET              ( -- )
    BEGIN  AFSTANDEN  RCKEY? UNTIL
    ;

\ Een RC-toetscode tegelijkertijd
: SKIP-RCKEY        ( -- )
    150 MS  RCKEY? IF  RCKEY DROP  THEN
    ;

FLAG STOP?

: START/STOP        ( -- )
    STOP? IF  STOP  ELSE  VOORUIT  THEN  TOGGLE STOP?
    ;

\ Handel RC-commando's af
: AFSTANDBEDIENING  ( -- )
    RCKEY? IF
        CASE  RCKEY  SKIP-RCKEY
            12 OF   MEET        ENDOF
            13 OF   START/STOP  ENDOF
            16 OF   HARDER      ENDOF
            17 OF   ZACHTER     ENDOF
            32 OF   RECHTSOM    ENDOF
            33 OF   LINKSOM     ENDOF
        ENDCASE
    THEN
    ;

\ Meet afstanden tot de batterijen leeg zijn.
:MAIN               ( -- )
    SETUP-USHI  30 SNELHEID  STOP
    $FF SETDIR PB   SET STOP?       \ Poort-B is led uitgang
    CLEAR PB 250 MS  SET PB 250 MS  \ Toon opstarten op de leds
    BEGIN  AFSTANDBEDIENING  AGAIN
    ;

                              ( Einde )
