\ ----------------------------------------------------------------------
\ LANGUAGE    : AVR ByteForth vsn 2.00
\ PROJECT     : Ushi-3 test nummer 5
\ DESCRIPTION : Test RC5 zender
\ CATEGORY    : Applicatie, afmeting: 214 bytes.
\ AUTHOR      : Willem Ouwerkerk, December 09, 2001
\ LAST CHANGE : Willem Ouwerkerk, Oktober 20, 2002
\ ----------------------------------------------------------------------

90S2313                                 \ Selecteer target
NEEDS TARGET.FRT                        \ Laad cpu specifiek deel
4 SET-CRYSTAL                           \ Gebruik 4 MHz kristal
NEEDS MS.FRT                            \ Laad geschikte MS versie



\ De leds in Ushi-2 zijn aangesloten op poort-B

PORTB SFR PB
PORTB 2 BIT-SFR RECHTS-OPZIJ
PORTB 6 BIT-SFR LINKS-OPZIJ

PORTD SFR PD
PORTD 1 BIT-SFR ACHTER
PORTD 2 BIT-SFR ZEND                    \ RC5-uitgang
PIND  3 BIT-SFR ONTVANG                 \ RC5-ingang

INCLUDE RC5ZEND.FRT


DOC het testen van de RC5 zender

Vergeet niet alle acht jumpers bij de leds te plaatsen !!!
De kabel van de IR-RC-print wordt aangesloten op connector
3 en 4 van Ushi.

Ushi toont op zijn led aan de achterkant dat de RC5 zender actief is.
Wordt de bumper schakelaar LINKS-OPZIJ ingedrukt dan wordt er een
1 verzonden, kanaal 1 op de TV moet nu actief worden.
Wordt de bumper schakelaar RECHTS-OPZIJ ingedrukt dan wordt er een
code 12 verzonden, de TV moet nu uit gaan.

ENDDOC

\ Zet achterste LED aan en wacht 100 ms, zet led uit en
\ wacht tot beide schakelaars losgelaten zijn.
: WACHT             ( -- )
    CLEAR ACHTER  100 MS  SET ACHTER
    BEGIN  FROM LINKS-OPZIJ UNTIL
    BEGIN  FROM RECHTS-OPZIJ UNTIL
    ;

\ Verzend twee verschillende codes met de RC5-zender van Ushi.
: ZENDER            ( -- )
    FROM LINKS-OPZIJ 0= IF   1 RCEMIT   WACHT  THEN
    FROM RECHTS-OPZIJ 0= IF  12 RCEMIT  WACHT  THEN
    ;

:MAIN               ( -- )
    $F6 SETDIR PD  0 SETDIR PB
    CLEAR ACHTER  250 MS  SET ACHTER    \ Opstart seintje
    BEGIN
        ZENDER
    AGAIN
    ;

                              ( Einde )
